////////////////////////////////////////////////////////////////////////////
// CEnvValSet 饹Υץơ
//
////////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include "EnvValSet.h"

using namespace std;

extern char **environ;

////////////////////////////////////////////////////////////////////////////
// /˴
////////////////////////////////////////////////////////////////////////////

CEnvValSet::CEnvValSet()
{
	ppOldEnvorn = NULL;
	listEnvVal.clear();
}

CEnvValSet::CEnvValSet( const CEnvValSet &r ) :
	ppOldEnvorn( r.ppOldEnvorn ),
	listEnvVal( r.listEnvVal )
{
}

CEnvValSet::~CEnvValSet()
{

}

////////////////////////////////////////////////////////////////////////////
// ᥽å
////////////////////////////////////////////////////////////////////////////

// ߤδĶѿ
void CEnvValSet::ReadEnvironment()
{
	char **pEnv;

	assert( !ppOldEnvorn && this );

	listEnvVal.clear();

	pEnv = environ;
	if ( NULL == pEnv ) return ;

	while ( (*pEnv) ) {
		listEnvVal.push_back( (*pEnv) );
		pEnv++;
	}
}

// Ķѿͤꤹ
bool CEnvValSet::WriteEnvironemnt()
{
	char **wp;
	int i;
	list< string >::iterator itr;

	assert( !ppOldEnvorn && this );

	// ߤͤ
	ppOldEnvorn = environ;

	// ꤹ٤ĶѿʤСenvironNULLꤹ롣
	if ( listEnvVal.empty() ) {
		environ = NULL;
		return true;
	}

	// ĶѿȤꤹʸۤ
	wp = (char**)calloc( listEnvVal.size() + 1, sizeof( char* ) );
	if ( NULL == wp ) return false;

	itr = listEnvVal.begin();
	i = 0;
	for (; itr != listEnvVal.end() && i < listEnvVal.size(); itr++, i++ ) {
		wp[i] = (char*)malloc( ( itr->length() + 1 ) * sizeof( char ) );
		if ( NULL == wp[i] ) {
			DestroyStr( wp );
			return false;
		}
		strcpy( wp[i], itr->c_str() );
	}

	// Ķѿѹ
	environ = wp;

	return true;
}

// ѹĶѿ򸵤᤹
void CEnvValSet::RestoreEnvironment()
{
	char **wp = environ;

	assert( this );

	// 򤷤Ƥͤ򸵤᤹
	environ = ppOldEnvorn;
	ppOldEnvorn = NULL;

	// ΰ
	DestroyStr( wp );
}

// ʸ󲽤ͤ
string CEnvValSet::GetString() const
{
	string rStr;
	list< string >::const_iterator itr;
	char buf[15];

	assert( this );

	// ͤΥХĹͤNULLʸ³롣
	// ƬˤϴĶѿθĿꤹ

	// ĶѿθĿ
	snprintf( buf, sizeof( buf ), "%d\0", listEnvVal.size() );
	rStr = buf;
	rStr += '\0';

	itr = listEnvVal.begin();
	for (; itr != listEnvVal.end(); itr++ ) {
		// ͤΥХȿ
		snprintf( buf, sizeof( buf ), "%d\0", itr->length() );
		rStr += buf;
		rStr += '\0';

		// 
		rStr += (*itr);
		rStr += '\0';
	}

	return rStr;
}

// ʸ󲽤ͤ顢Ķѿͤ
void CEnvValSet::SetString( const string &r )
{
	int i;
	const char *p;
	const char *pEnd;
	int cnt;
	string EnvVal;
	int EnvValLen;

	assert( !ppOldEnvorn && this );

	listEnvVal.clear();
	if ( r.length() <= 0 ) return ;

	// ĶѿθĿ
	cnt = atoi( r.c_str() );

	pEnd = r.c_str() + r.size();
	p = r.c_str() + strlen( r.c_str() ) + 1;
	i = 0;
	while ( p < pEnd && i < cnt ) {
		// ͤΥХĹ
		EnvValLen = atoi( p );
		p += strlen( p ) + 1;
		if ( p >= pEnd ) break;
		if ( p + EnvValLen >= pEnd ) break;

		// ͤ
		EnvVal = r.substr( p - r.c_str(), EnvValLen );
		p += EnvValLen + 1;

		// ꥹȤɲ
		listEnvVal.push_back( EnvVal );
		i++;
	}
}

// Ƥΰ
void CEnvValSet::DestroyStr( char** p ) const
{
	char **wp = p;

	if ( !wp ) return ;

	while ( (*wp) ) {
		free( (*wp) );
		(*wp) = NULL;
		wp++;
	}
	free( p );
}
